Subject: FvwmProxy role, addendum

From: [email-masked]
Date: Wed, 20 Nov 2002 18:33:25 -0800

I've fiddled a little with the core Next/Prev and am a little surprised
by it's behavior.

Next seems to proceed through the windows, but not in any predictable order
and not even in a consistant order.  It seems to change order even when I
haven't moved any windows.

Prev only seems to flip between the current window and some other window
(last focused, maybe).  It is not the reverse of Next.

Direction seemed promising but it doesn't hit everything.  It skips right
past windows that are closer in the direction specified but farther in
the overall distance.  If some windows can't be hit, that makes it pretty
worthless.  And it doesn't loop around.

Unless someone can point out how I've misused these, this seems to oppose
my condition that Next/Prev displayed reasonable behavior.

I suppose we can keep the proxy Next/Prev and have circulate call
those if the user so desires.  It does make the value of circulate
appear a little weaker considering the potential confusion of the
Config file issue.

Or maybe we need an option or alternative to Direction to be "next in
the given direction only considering that primary axis or next in the opposing
axis if other windows have the same location along the primary axis".  That's
what FvwmProxy is doing now.  By the way, this is 35 lines of code, so
I wouldn't neccessarily get too excited about potential redundancy.

Also, there's no condition !WindowListSkip, although AcceptsFocus seems to
do the trick, at least with the one skipped window I have.

-- 
  _
 ( \      _  \    /_ /  _ _  Jason Weber                  (503) 380-7424
  \|(\/)()))  \/\/(-/_)(-/(  Infinite Monkeys Inc.        Aloha, Oregon
  //                         http://www.imonk.com/baboon  [email-masked]
 (/     [email-masked]        [email-masked]

     "Canister contains at least 50% recycled material; 15%
      post-consumer content."
   -- Pringles Fat-Free (side of can)
--
Visit the official FVWM web page at <URL:http://www.fvwm.org/>.
To unsubscribe from the list, send "unsubscribe fvwm-workers" in the
body of a message to [email-masked].
To report problems, send mail to [email-masked]

---

From: Dominik Vogt <[email-masked]>
Date: Thu, 21 Nov 2002 11:23:56 +0100

> haven't moved any windows.

Next and Prev order are based on the creation order or the order
in which windows were focused, depending on the focus policy.  The
latter is the usua "Alt-Tab" behaviour.

> (last focused, maybe).  It is not the reverse of Next.

Sounds wrong.  I have to check this.  Worked for me last time I
tried... No, still works for me.  

> worthless.  And it doesn't loop around.

I use Direction all the day with just N/S/E/W and I can always hit
any window.  But of course that depends on the page layout.

> what FvwmProxy is doing now.

Yes, I think we should have some command that just scans windows
from left to right and top to bottom (configurable).  For example

  # "next" replacement
  ScanWindow Right Down (CurrentPage) ...
  # "prev" replacement
  ScanWindow Left Up (CurrentPage) ...

Essentially, this is just a different scoring algorithm for the
Direction code.

> By the way, this is 35 lines of code, so

Unfortunately these things have the habit to grow out of control.
Changes are good that patches will soon get committed that add the
other conditional commands with additional options, etc.  Just take
a look at all the different options that FvwmWinList, FvwmTaskBar,
FvwmIconMan, WindowList etc. take.  They could all benefit from
the same window selection options :-/

> Also, there's no condition !WindowListSkip,

It's called "CirculateHit".

> although AcceptsFocus seems to

Bye

Dominik ^_^  ^_^